﻿using System;
using System.Drawing;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading;
using System.Collections;
using System.Runtime.InteropServices;
using System.Diagnostics;


namespace SPP_Test_Executive_Project 
{
    public partial class SPP_Test_Executive_Project 
    {

        //Parameters
        public byte COMMAND_DECODE = 0x38;
        public const int AH_CS_UNRELIABLE_DROP = 0;                       // Flag of dropped data
        public const int AH_CS_UNRELIABLE_FLUSH = 1;
        public const byte TRIGGER_COMMAND = 0x05;
        public const byte BYTE_TRANSFER_COMMAND = 0x06;
        public const byte BLOCK_TRANSFER_COMMAND = 0x07;
      	public const byte READ_CONTROL_WORD = 0x00;

        //Start of Class Methods

        private void MDT_AH_SendTrigger(byte trigger_value)
		{
            byte tempVar = 0;
            PutBuff = new char[1];

            tempVar = (TRIGGER_COMMAND << 4);

            // Load element 0 with the Instruction.
            PutBuff[0] = (char)(READ_CONTROL_WORD + tempVar + 0x00);
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);

            // Load element 0 with the Instruction.
            PutBuff[0] = (char)trigger_value;
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);
		}
		
        private void MDT_AH_SendByte(byte device_channel, byte data_byte)
		{
            byte tempVar = 0;
            PutBuff = new char[1];

            tempVar = (BYTE_TRANSFER_COMMAND << 4);
            // Load element 0 with the Instruction.
            PutBuff[0] = (char)(READ_CONTROL_WORD + tempVar + device_channel);
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);

            // Load element 0 with the Instruction.
            PutBuff[0] = (char)data_byte;
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);
		}
		
        private void MDT_AH_SendBlock(byte device_channel, byte data_size)
		{
            PutBuff = new char[1];

            // Load element 0 with the Instruction.
            PutBuff[0] = (char)(READ_CONTROL_WORD + BLOCK_TRANSFER_COMMAND << 4 + device_channel);
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);

            // Load element 0 with the Instruction.
            PutBuff[0] = (char)data_size;
            //Send byte to COM Port
            serialPort_STEP.Write(PutBuff, 0, 1);
		}
		
        private void MDT_AH_SendTransferControlByte(char address_to_device, char payload)
		{
		}
		
        private void MDT_AH_RegisterReadCallback(IntPtr read_callback)
		{
		}
		
      
        // Actual callback function which will read messages coming from the MDT device
         private void MDTReadFunction(Int32 device_id, Int32 device_channel, byte command, byte payload, byte data_size)
        {
        }

        // **************** START OF CALLBACK REGISTRATION CODE *****************
        // Register the callback function
        // Declare pointer type of the callback function
         private void MDTRegisterCallBack()
        {
        }
        // **************** END OF CALLBACK REGISTRATION CODE *******************




    }
}
