library verilog;
use verilog.vl_types.all;
entity EPT_10M04_AF_S2_Top is
    generic(
        IDLE            : integer := 0;
        SELECT_MODE     : integer := 1;
        LOAD_REGISTER   : integer := 2;
        LOAD_LEDS       : integer := 3;
        WAIT_FOR_TIMER  : integer := 6;
        GLOBAL_RESET_COUNT: vl_logic_vector(0 to 11) := (Hi1, Hi0, Hi0, Hi1, Hi1, Hi1, Hi0, Hi0, Hi1, Hi0, Hi0, Hi0);
        RANDOM_NUMBER   : vl_logic_vector(0 to 3) := (Hi0, Hi0, Hi0, Hi1);
        SHIFT_LEFT      : vl_logic_vector(0 to 3) := (Hi0, Hi0, Hi1, Hi0);
        SHIFT_RIGHT     : vl_logic_vector(0 to 3) := (Hi0, Hi0, Hi1, Hi1);
        COUNT_UP        : vl_logic_vector(0 to 3) := (Hi0, Hi1, Hi0, Hi0);
        COUNT_DOWN      : vl_logic_vector(0 to 3) := (Hi0, Hi1, Hi0, Hi1);
        STATIC_VALUE    : vl_logic_vector(0 to 5) := (Hi0, Hi0, Hi0, Hi1, Hi1, Hi0);
        TIMER_LOW_LIMIT : vl_logic_vector(0 to 23) := (Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi0, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1, Hi1)
    );
    port(
        CLK_10MHZ       : in     vl_logic;
        CLK_32KHZ       : in     vl_logic;
        RST             : in     vl_logic;
        CLK_10MHZ_ENABLE: out    vl_logic;
        CLK_32KHZ_ENABLE: out    vl_logic;
        XIO_1           : out    vl_logic_vector(7 downto 0);
        XIO_2           : out    vl_logic_vector(7 downto 0);
        XIO_3           : out    vl_logic_vector(7 downto 0);
        XIO_4           : out    vl_logic_vector(7 downto 0);
        LED             : out    vl_logic_vector(3 downto 0)
    );
    attribute mti_svvh_generic_type : integer;
    attribute mti_svvh_generic_type of IDLE : constant is 1;
    attribute mti_svvh_generic_type of SELECT_MODE : constant is 1;
    attribute mti_svvh_generic_type of LOAD_REGISTER : constant is 1;
    attribute mti_svvh_generic_type of LOAD_LEDS : constant is 1;
    attribute mti_svvh_generic_type of WAIT_FOR_TIMER : constant is 1;
    attribute mti_svvh_generic_type of GLOBAL_RESET_COUNT : constant is 1;
    attribute mti_svvh_generic_type of RANDOM_NUMBER : constant is 1;
    attribute mti_svvh_generic_type of SHIFT_LEFT : constant is 1;
    attribute mti_svvh_generic_type of SHIFT_RIGHT : constant is 1;
    attribute mti_svvh_generic_type of COUNT_UP : constant is 1;
    attribute mti_svvh_generic_type of COUNT_DOWN : constant is 1;
    attribute mti_svvh_generic_type of STATIC_VALUE : constant is 1;
    attribute mti_svvh_generic_type of TIMER_LOW_LIMIT : constant is 1;
end EPT_10M04_AF_S2_Top;
