library verilog;
use verilog.vl_types.all;
entity serial_uart_comms_model is
    generic(
        IDLE            : integer := 0;
        WAIT_FOR_CMD    : integer := 1;
        CMD_TX_WRITE    : integer := 2;
        WRITE_CMD_NOP   : integer := 3;
        WR_CMD_WAIT_BUF_EMPTY: integer := 4;
        DATA_TX_WRITE   : integer := 5;
        WRITE_DATA_NOP  : integer := 6;
        WR_DATA_WAIT_BUF_EMPTY: integer := 7;
        RECEIVE_BYTE    : integer := 8;
        COUNT_TO_DECIMAL: integer := 4;
        COUNT_TO_DECIMAL_3: integer := 54;
        COUNT_TO_DECIMAL_2: integer := 35;
        COUNT_TO_DECIMAL_1: integer := 5
    );
    port(
        CLK             : in     vl_logic;
        RESET           : in     vl_logic;
        UART_RXD_IN     : in     vl_logic;
        UART_TXD_OUT    : out    vl_logic;
        CONTROL_REGISTER: out    vl_logic_vector(7 downto 0);
        STATUS_REGISTER : in     vl_logic_vector(7 downto 0);
        RECEIVE_REGISTER: out    vl_logic_vector(15 downto 0);
        SEND_REGISTER   : in     vl_logic_vector(15 downto 0)
    );
end serial_uart_comms_model;
