library verilog;
use verilog.vl_types.all;
entity uart_tiny_slave is
    generic(
        IDLE            : integer := 0;
        RECEIVE_DATA    : integer := 1;
        STORE_BYTE      : integer := 2;
        SEND_TO_HOST    : integer := 3;
        RECEIVE_COMPLETE: integer := 4;
        WRITE_REGISTER  : integer := 5;
        LOAD_SHIFT_REG  : integer := 6;
        DELAY_WRITE_DATA_BYTE: integer := 7;
        WRITE_DATA_BYTE : integer := 8;
        WRITE_DATA_COMPLETE: integer := 9;
        COUNT_TO_DECIMAL: integer := 4;
        COUNT_TO_DECIMAL_3: integer := 54;
        COUNT_TO_DECIMAL_2: integer := 35;
        COUNT_TO_DECIMAL_1: integer := 5
    );
    port(
        CLK             : in     vl_logic;
        RST_N           : in     vl_logic;
        UART_OUT        : out    vl_logic;
        UART_IN         : in     vl_logic;
        USB_RXF_N       : in     vl_logic;
        USB_TXE_N       : in     vl_logic;
        USB_DATA        : inout  vl_logic_vector(7 downto 0);
        USB_RD_N        : out    vl_logic;
        USB_WR          : out    vl_logic;
        USB_SI          : out    vl_logic;
        TR_DIR_1        : out    vl_logic;
        TR_OE_1         : out    vl_logic;
        TR_DIR_2        : out    vl_logic;
        TR_OE_2         : out    vl_logic;
        TR_DIR_3        : out    vl_logic;
        TR_OE_3         : out    vl_logic
    );
end uart_tiny_slave;
